/*
 * $Id: clu2c.h,v 2.0 1992/09/23 12:19:28 toh-hei Exp $
 *
 * Copyright (c) 1992 Kimura Laboratory, Department of Information Science,
 * Tokyo Institute of Technology.  All rights reserved.
 *
 */

/* return value of function */
#define SIG 0       /* when occur signal in func */
#define RET 1       /* normally finish in func*/

#define NO_OPERATION (0)       /* placed after label */

/* for GC */
#define malloc gc_malloc
#define free gc_free
#define malloc_atomic gc_malloc_atomic

/* for istream and encode/decode */
#define NOT_YET 0

/* CLU "return" and "signal" statements */

#define RETURN0\
	return RET
#define RETURN1(res1)\
	retval_area[0] = (elt) (res1);\
	return RET
#define RETURN2(res1,res2)\
	retval_area[0] = (elt) (res1);\
	retval_area[1] = (elt) (res2);\
	return RET
#define RETURN3(res1,res2,res3)\
	retval_area[0] = (elt) (res1);\
	retval_area[1] = (elt) (res2);\
	retval_area[2] = (elt) (res3);\
	return RET

#define SIGNAL0(except)\
	signame = (except);\
	return SIG
#define SIGNAL1(except,res1)\
	signame = (except);\
	sigarg_area[0] = (elt) (res1);\
	return SIG
#define SIGNAL2(except,res1,res2)\
	signame = (except);\
	sigarg_area[0] = (elt) (res1);\
	sigarg_area[1] = (elt) (res2);\
	return SIG
#define SIGNAL3(except,res1,res2,res3)\
	signame = (except);\
	sigarg_area[0] = (elt) (res1);\
	sigarg_area[1] = (elt) (res2);\
	sigarg_area[2] = (elt) (res3);\
	return SIG
