/* 
 * $Id: null.c,v 2.0 1992/09/23 08:42:55 toh-hei Exp $
 *
 * Copyright (c) 1992 Kimura Laboratory, Department of Information Science,
 * Tokyo Institute of Technology.  All Rights Reserved.
 *
 */

/* fully implemented */

#include <clu2c.h>
#include <type.h>
#include <glo.h>

/*
 * equal = proc(null,null)returns(null)
 */

int null_equal(null n1, null n2)
{
	retval_area[0] = TRUE;
	return(RET);
}

/*
 * similar = proc(null,null)returns(null)
 */

int null_similar(null n1, null n2)
{
	retval_area[0] = TRUE;
	return(RET);
}

/*
 * copy = proc(null)returns(null)
 */

int null_copy(null n)
{
	retval_area[0] = NIL;
	return(RET);
}

/*
 * print = proc(n: null, pst: pstream) 
 */

int null_print(null n, clus pst)
{
    if ( _cpstream_text(pst, "nil") == SIG ) {
	out_handler();
	return(SIG);
    }
    return(RET);
}

/*
 *  encode = proc(n: null, s: istream) signals(not_possible(string))
 *	modifies  s.
 *	effects  Writes an encoding of n onto the istream s.
 */

int null_encode(null n, istream s)
{
    return(istream_puti(s, NIL));
}

/*
 *  decode = proc(s: istream) returns(null)
 *			      signals(end_of_file, not_possible(string))
 *	modifies  s.
 *	effects  Decodes the information written by encode operations
 *	    and return an object "similar" to the one encoded.
 */

int null_decode(istream s)
{
    if (istream_geti(s) == SIG) {
	return(SIG);
    }
    if (retval_area[0] != NIL) {
	sigarg_area[0] = (elt) "bad format";
	signame = "not_possible";
	return(SIG);
    }
    return(RET);
}

/*
 * _gcd = proc(n: null, tab: gcd_tab) returns(int)
 */

/* stub version */

int null__gcd(null n, clus tab)
{
    signame = "failure";
    sigarg_area[0] = (elt) "null$_gcd: not implemented";
    return(SIG);
}
