/*
 * $Id: proctype.c,v 2.0 1992/09/23 08:43:37 toh-hei Exp $
 *
 * Copyright (c) 1992 Kimura Laboratory, Department of Information Science,
 * Tokyo Institute of Technology.  All rights reserved.
 *
 */

#include <clu2c.h>
#include <type.h>
#include <glo.h>

static char rcsid[] = "$Id: proctype.c,v 2.0 1992/09/23 08:43:37 toh-hei Exp $";

/*
 * equal = proc(x, y: t) returns(bool)
 *   effects  Returns true if and only if  x  and  y  are the same
 *	module with the same parameters.
 *
 *	(  t  stands for a proctype) 
 */

int proctype_equal(proctype x, proctype y)
{
    retval_area[0] = (elt) (x == y);
    return RET;
}

/*
 * similar = proc(x, y: t) returns(bool)
 *   effects  Returns true if and only if  x  and  y  are the same
 *	module with the same parameters.
 *
 *	(  t  stands for a proctype) 
 */

int proctype_similar(proctype x, proctype y)
{
    retval_area[0] = (elt) (x == y);
    return RET;
}

/*
 * copy = proc(x: t) returns(y: t)
 *   effects  Returns  y  such that  x  =  y  .
 *
 *	(  t  stands for a proctype)
 */

int proctype_copy(proctype x)
{
    retval_area[0] = (elt) x;
    return RET;
}
